
//IIOP version
//George Koutsogiannakis

import java.rmi.*;
import java.rmi.server.*;
//add the lines below
import javax.rmi.PortableRemoteObject;
import javax.naming.*;
import java.net.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class ReverseInterfaceImpl extends PortableRemoteObject implements ReverseInterface

{
	public ReverseInterfaceImpl() throws RemoteException
	{
		super();
	}
	public String reverseString(String originalstring) throws RemoteException
	{
		int length=originalstring.length();
		StringBuffer temp=new StringBuffer(length);
		for (int i=length; i>0; i-- )
		{
			temp.append(originalstring.substring(i-1,i));
		}
		return temp.toString();
	}

	public static void main(String[] args)
	{
		
		
		try
		{
			
			ReverseInterfaceImpl r= new ReverseInterfaceImpl();
			//add the follwoing lines
			Context initialNamingContext=new InitialContext();
			System.out.println("Binding server to registry..");
			initialNamingContext.rebind("Reverse",r);
			System.out.println("Object was registered");
			//Naming.rebind(name, r);
			
		}
		catch(Exception e) {
			System.out.println("Error while binding object 11:00am");
			System.out.println(e.toString());
		}
		System.out.println("The RMI server is up and Running!");
	}

}


